# Rules.make for uClibc test apps.
#
# Copyright (C) 2001 by Lineo, inc.
#
#
#Note: This does not read the top level Rules.mak file
#

include $(APPSTOP)../ProductName
include $(APPSTOP)../ProductModules
include $(APPSTOP)../ProductKernel
include $(B4X_ROOT)/ProductConfig
#include $(B4X_ROOT)/ProductName
#include $(B4X_ROOT)/ProductModules
#include $(B4X_ROOT)/ProductKernel

# by jkglee
UCLIBCDIR = $(APPSTOP)../$(GB_LIBC_VERSION)/
#UCLIBCDIR = $(B4X_ROOT)/$(GB_LIBC_VERSION)/
include $(UCLIBCDIR).config

INSTALL_PATH_BIN = $(B4X_ROOT)/prods/B4X/romdisk/bin

# by jkglee
DODEBUG = false
DODYNAMIC = false

# by jkglee
CFLAGS += -I$(APPSTOP)../include


# Use NATIVE_ARCH here since running these test is not
# even possible when cross compiling...
NATIVE_ARCH:= ${shell uname -m | sed \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234].*/sh/' \
		-e 's/mips.*/mips/' \
		}
ifeq ($(strip $(TARGET_ARCH)),)
TARGET_ARCH_X :=${shell $(CC) -dumpmachine | sed -e s'/-.*//' \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234]/sh/' \
		-e 's/mips.*/mips/' \
		}
endif


# If you are running a cross compiler, you may want to set this
# to something more interesting...
# by jkglee
##CC = $(UCLIBCDIR)extra/gcc-uClibc/$(TARGET_ARCH_X)-uclibc-gcc
#spark 20031016
CC = $(UCLIBCDIR)extra/gcc-uClibc/arm-uclibc-gcc
LD = $(UCLIBCDIR)extra/gcc-uClibc/arm-uclibc-ld
#spark 20031114
AR = arm-elf-ar
RANLIB = arm-elf-ranlib
#CC = ../$(TESTDIR)extra/gcc-uClibc/$(TARGET_ARCH)-uclibc-gcc
HOST_CC = gcc
STRIPTOOL=strip
# by jkglee
#LDD = ../$(TESTDIR)ldso/util/ldd


# Check if 'ls -sh' works or not
LSFLAGS = -l

# turn all the warnings on
WARNINGS=-Wall

# use '-Os' optimization if available, else use -O2
OPTIMIZATION = ${shell if $(CC) -Os -S -o /dev/null -xc /dev/null >/dev/null 2>&1; \
    then echo "-Os"; else echo "-O2" ; fi}

ifeq ($(DODEBUG),true)
    CFLAGS +=$(WARNINGS) $(OPTIMIZATION) -g
    GLIBC_CFLAGS +=$(WARNINGS) $(OPTIMIZATION) -g
    LDFLAGS =-Wl,-warn-common
    GLIBC_LDFLAGS =-Wl,-warn-common 
    STRIPTOOL =/bin/true -Since_we_are_debugging
else
    CFLAGS  +=$(WARNINGS) $(OPTIMIZATION) -fomit-frame-pointer
    GLIBC_CFLAGS  +=$(WARNINGS) $(OPTIMIZATION) -fomit-frame-pointer
    LDFLAGS  =-s -Wl,-warn-common
    GLIBC_LDFLAGS  =-s -Wl,-warn-common
    STRIP    = $(STRIPTOOL) --remove-section=.note --remove-section=.comment $(PROG)
endif

ifneq ($(DODYNAMIC),true)
    LDFLAGS +=--static
    GLIBC_LDFLAGS +=--static
endif
CFLAGS+=--uclibc-use-build-dir -Dlinux
LDFLAGS+=--uclibc-use-build-dir 

# TSHwang 2004.01.15 for PIC
CFLAGS += -D__PIC__ -fpic -msingle-pic-base -mstructure-size-boundary=8

##CFLAGS+= -Wl,-elf2flt
CFLAGS+= -Wl,
LDFLAGS += -elf2flt -L$(UCLIBCDIR)libgigarouter -L$(UCLIBCDIR)libz 

ifeq ($(HAS_MULTI_SESSION),y)
	CFLAGS += -DHAS_MULTI_SESSION
endif

ifeq ($(HAS_PCMCIA),y)
	CFLAGS += -DHAS_PCMCIA
	ifeq ($(HAS_PCMCIA_WIRELESS),y)
		CFLAGS += -DHAS_PCMCIA_WIRELESS
		ifeq ($(HAS_PCMCIA_WIRELESS_AR5K),y)
			CFLAGS += -DHAS_PCMCIA_WIRELESS_AR5K
		endif
		ifeq ($(HAS_PCMCIA_WIRELESS_PRISM_TERTIARY),y)
			CFLAGS += -DHAS_PCMCIA_WIRELESS_TERTIARY
		endif
	endif
endif


ifeq ($(HAS_RIP),y)
	CFLAGS += -DHAS_RIP
endif

ifeq ($(HAS_UPNP),y)
	CFLAGS += -DHAS_UPNP
endif

ifeq ($(HAS_DDNS),y)
	CFLAGS += -DHAS_DDNS
endif

ifeq ($(HAS_URLBLOCKING),y)
       CFLAGS += -DHAS_URLBLOCKING
endif

#ifeq ($(ENABLE_PNP_SETUP),y)
	CFLAGS += -DENABLE_PNP_SETUP
#endif
