/*=======================================================================
; Comment: Java Script for checking Static Routing Metric Number
; IN : Data String, Check NULL Flag, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckMetric(MetricNum, NullCheckFlg, err_mess)
{
    if(NullCheckFlg==0 && Trim(MetricNum.value)==""){
        MetricNum.value="";
        return true;
    }else{
        /* do nothing */
    }
    if ( NumberCheck(MetricNum.value) == false ){
        if(err_mess){
            alert("Invalid Metric Number ( "+ MetricNum.value +" ).");
            MetricNum.value = "";
            return false;
        }else{
            /* do nothing */
        }
    }else{
        /* do nothing */
    }
    d = parseInt(MetricNum.value, 10);
    if (d<1 || d>15){
        alert("Invalid Metric Range from 1 to 15 ( "+ MetricNum.value +" ).");
        MetricNum.value = "";
        return false;
    }else{
        MetricNum.value = d ;
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking Static Route
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckStaticRoute(form)
{
    var flag = true;
    
    for(var i = 1; i <= 4; i++){
        flag = true;
        var ipaddr_s1 = eval("form.static_route_ipaddr"+(i));
        var ipaddr_s2 = eval("form.static_route_netmask"+(i));
        var ipaddr_s3 = eval("form.static_route_gateway"+(i));
        var ipaddr_s4 = eval("form.static_route_metric"+(i));

        if( ipaddr_s1.value=="" && ipaddr_s2.value=="" && ipaddr_s3.value=="" && ipaddr_s4.value==""){
            /* do nothing */
        }else{
            if( Trim(ipaddr_s4.value) == "" ){
                alert("No."+ i +" Empty Metric Number.");
                flag = false;
            }else if( CheckIPAddress(ipaddr_s1, 1, 1) && CheckNetmask(ipaddr_s2, 1, 1) && CheckIPAddress(ipaddr_s3, 1, 1) && CheckMetric(ipaddr_s4, 1, 1) ){
            	flag = true;
            }else{
                alert("No."+ i +" Staic Route Table setting fail.");
                flag = false;
            }
        }
        
        if(flag == false){
            break;
        }else{
            /* do nothig */
        }
    }
    return flag;
}