/*=======================================================================
; Comment: Java Script for WAN PPPoE Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckWANPPPoE(form)
{
    //Note: username or password is occasionally none.
    if(form.record_name.value.length == 0){
        alert("Please input ISP Name.");
        return false;
    }else{
        if( CheckISPName(form.record_name, 20) &&
            CheckText(form.ppp_username) &&
            CheckText(form.ppp_password) &&
            CheckText(form.pppoe_servicename) &&
            CheckText(form.pppoe_acname) &&
            CheckText(form.dns_domainname) &&
            CheckIPAddress(form.dns_ipaddr1,0, 1) &&
            CheckIPAddress(form.dns_ipaddr2,0, 1) &&
            CheckMTU(form.wan_mtu,0) ){
            return true;
        }else{
            alert("Please reset PPPoE configuration.");
            return false;
        }
    }
}

/*=======================================================================
; Comment: Java Script for Basic WAN PPPoE Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckBasicWANPPPoE(form)
{
    if((Trim(form.ppp_username.value) == "") || (Trim(form.ppp_password.value) == "")){
        alert("Please Input User Name or Password.");
        return false;
    }else{
        /* do nothing */
    }
    if( CheckText(form.ppp_username) &&
        CheckText(form.ppp_password) ){
        return true;
    }else{
        alert("Please reset PPPoE configuration.");
        return false;
    }
}

/*=======================================================================
; Comment: Java Script for WAN PPPoE Unnumber Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckWANPPPoELan(form)
{
    //Note: username or password is occasionally none.
    if(form.record_name.value.length == 0){
        alert("Please input ISP Name.");
        return false;
    }else if(form.wan_ipaddr.value=="" || form.wan_netmask.value==""){
        alert("Please input WAN IP or WAN Netmask.");
        return false;
    }else{
        if( CheckISPName(form.record_name, 20) &&
            CheckText(form.ppp_username) &&
            CheckText(form.ppp_password) &&
            CheckText(form.pppoe_servicename) &&
            CheckText(form.pppoe_acname) &&
            CheckText(form.dns_domainname) &&
            CheckIPAddress(form.dns_ipaddr1,0, 1) &&
            CheckIPAddress(form.dns_ipaddr2,0, 1) &&
            CheckIPAddress(form.wan_ipaddr,0, 1) &&
            CheckNetmask(form.wan_netmask,0, 1) &&
            CheckMTU(form.wan_mtu,0) &&
            CheckMTU(form.wan_mtu,0) ){
            return true;
        }else{
            alert("Please reset PPPoE Unnumber configuration.");
            return false;
        }
    }
}

/*=======================================================================
; Comment: Java Script for Basic WAN PPPoE Unnumber Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckBasicWANPPPoELan(form)
{
    if((Trim(form.ppp_username.value) == "") || (Trim(form.ppp_password.value) == "") ||
       (Trim(form.wan_ipaddr.value) == "") || (Trim(form.wan_netmask.value) == "")){
        alert("Please Input User Name or Password or WAN IP or WAN Netmask.");
        return false;
    }else{
        /* do nothing */
    }
    if( CheckText(form.ppp_username) &&
        CheckText(form.ppp_password) &&
        CheckIPAddress(form.wan_ipaddr,0, 1) &&
        CheckNetmask(form.wan_netmask,0, 1) ){
            return true;
        }else{
            alert("Please reset PPPoE Unnumber configuration.");
            return false;
        }
}

/*=======================================================================
; Comment: Java Script for WAN Static IP Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckWanStatic(form)
{
    if(form.record_name.value.length == 0){
        alert("Please input ISP Name.");
        return false;
    }else if(form.wan_ipaddr.value=="" || form.wan_netmask.value==""){
        alert("Please input WAN IP or WAN Netmask.");
        return false;
    }else{
        if( CheckISPName(form.record_name, 20) &&
            CheckIPAddress(form.wan_gateway,0, 1) &&
            CheckIPAddress(form.dns_ipaddr1,0, 1) &&
            CheckIPAddress(form.dns_ipaddr2,0, 1) && 
            CheckIPAddress(form.wan_ipaddr,0, 1) &&
            CheckNetmask(form.wan_netmask,0, 1) &&
            CheckText(form.dns_domainname) &&
            CheckMTU(form.wan_mtu,0) ){
            return true;  
        }else{
            alert("Please reset Static IP configuration.");
            return false;
        }
    }
}

/*=======================================================================
; Comment: Java Script for Basic WAN Static IP Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckBasicWanStatic(form)
{
    if((Trim(form.wan_ipaddr.value) == "") || 
       (Trim(form.wan_netmask.value) == "") ||
       (Trim(form.wan_gateway.value) == "") ){
        alert("Please Input WAN IP or WAN Netmask or WAN Gateway.");
        return false;
    }else{
        /* do nothing */
    }
    if( CheckIPAddress(form.wan_gateway,0, 1) &&
        CheckIPAddress(form.dns_ipaddr1,0, 1) &&
        CheckIPAddress(form.dns_ipaddr2,0, 1) && 
        CheckIPAddress(form.wan_ipaddr,0, 1) &&
        CheckNetmask(form.wan_netmask,0, 1) ){
        return true;  
    }else{
        alert("Please reset Static IP configuration.");
        return false;
    }
}

/*=======================================================================
; Comment: Java Script for WAN DHCP Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckWanDHCP(form)
{
    if(form.record_name.value.length == 0){
        alert("Please input ISP Name.");
        return false;
    }else{
       if( CheckISPName(form.record_name, 20) &&
           CheckText(form.wan_hostname) &&
           CheckText(form.dns_domainname) &&
           CheckIPAddress(form.wan_gateway,0, 1) &&
           CheckIPAddress(form.dns_ipaddr1,0, 1) &&
           CheckIPAddress(form.dns_ipaddr2,0, 1) &&
           CheckMTU(form.wan_mtu,0) ){
           return true;
       }else{
           alert("Please input DHCP configuration.");
           return false;
       }
   }
}

/*=======================================================================
; Comment: Java Script for Basic WAN DHCP Connection
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckBasicWanDHCP(form)
{
    if(Trim(form.wan_hostname.value) == ""){
        //alert("Please Input Host Name.");
        //return false;
        return true;
    }else{
        /* do nothing */
    }
    if(CheckText(form.wan_hostname)){
        return true;
    }else{
        alert("Please input DHCP configuration.");
        return false;
    }
}
