/*=======================================================================
; Comment: Java Script for checking Wireless SSID
; IN : SSID String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckSSID(rf_ssid)
{
    var ss = new String(rf_ssid.value);
    var len = ss.length;
    var flag = false;
    
    if(len>32){
        alert("SSID Data Excess 32 Length");
        return false;
    }else{
        flag = true;
        for(var i=0;i<len;i++){
            /* AscCode 0x20 to 0x7e Accept */
            if(ss.charAt(i)>=' ' && ss.charAt(i)<='~'){
                /* do nothing */
            }else{
                flag = false;
                break;
            }
        }
        if(len ==0){
            flag = false;
        }else{
            /* do nothing */
        }
        if(flag == false){
            alert("Invalid SSID Input.");
        }else{
            /* do nothing */
        }
        return flag;
    }
}

/*=======================================================================
; Comment: Java Script for checking Wireless WEP KEY
; IN : WEP KEY String, Form Type, Error Message Flag
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWepKey(key, form, err_mess)
{
    var key_select = form.rf_key_select.value;
    var wep_type = form.rf_wep.value;
    var chk_key_No;
    var key_len = key.value.length;
    
    if(key.name.match(/[1]$/)){
        chk_key_No = 1;
    }else if(key.name.match(/[2]$/)){
        chk_key_No = 2;
    }else if(key.name.match(/[3]$/)){
        chk_key_No = 3;
    }else if(key.name.match(/[4]$/)){
        chk_key_No = 4;
    }else{
        /* do nothing */
    }
    
    //if(chk_key_No == key_select){
    if(1){
        switch(wep_type){
        case '0':
             if(key.value == "**********"
                || key.value == "**************************"
                || key.value == "********************************"
                || key_len == 0
                || (key_len == 14 && key.value.match(/^([A-Fa-f0-9]{2}\-){4}[A-Fa-f0-9]{2}$/))
                || (key_len == 38 && key.value.match(/^([A-Fa-f0-9]{2}\-){12}[A-Fa-f0-9]{2}$/))
                || (key_len == 47 && key.value.match(/^([A-Fa-f0-9]{2}\-){15}[A-Fa-f0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '1':
             if(key.value == "**********"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 14 && key.value.match(/^([A-Fa-f0-9]{2}\-){4}[A-Fa-f0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '2':
             if(key.value == "**************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 38 && key.value.match(/^([A-Fa-f0-9]{2}\-){12}[A-Fa-f0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '3':
            if(key.value == "********************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 47 && key.value.match(/^([A-Fa-f0-9]{2}\-){15}[A-Fa-f0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        }
    }else{
        if(key.value == "**********"
           || key.value == "**************************"
           || key.value == "********************************"
           || key_len == 0
           || (key_len == 14 && key.value.match(/^([A-Fa-f0-9]{2}\-){4}[A-Fa-f0-9]{2}$/))
           || (key_len == 38 && key.value.match(/^([A-Fa-f0-9]{2}\-){12}[A-Fa-f0-9]{2}$/))
           || (key_len == 47 && key.value.match(/^([A-Fa-f0-9]{2}\-){15}[A-Fa-f0-9]{2}$/))){
            return true;
        }else{
            /* do nothing */
        }
    }
    if(err_mess){
        alert("Invalid WEP KEY ( "+key.value+" ).");
        key.value = "";
    }else{
        /* do nothing */
    }
    return false;
    
}

/*=======================================================================
; Comment: Java Script for checking Wireless 1
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWireless(form)
{
    var flag=false;
    if(CheckSSID(form.rf_ssid)){
        flag=true;
    }else{
        /* do nothing */
    }

    if(form.rf_wep.selectedIndex == "0"){
        flag=true;
    //}else if(form.rf_wep.selectedIndex == "1"){
    //    var key_index = form.rf_key_select.value;
    //    var key_s = eval("form.rf_key_hex"+key_index);
    //    
    //    if(!CheckWepKey(key_s, form, 0)){
    //        alert("Invalid KEY Input in ( "+key_index+" ).");
    //        flag=false;
    //    }else{
    //        /* do nothing */
    //    }
    }else{
        for(var i=1;i<5;i++){
            var key_s = eval("form.rf_key_hex"+i);
            if(!CheckWepKey(key_s, form, 0)){
                alert("Invalid KEY Input in ( "+i+" ).");
                flag=false;
                break;
            }else{
                /* do nothing */
            }
        }
    }

    if (flag == false) {
        return flag;
    } else {
        /* do nothing */
    }

    if ((form.rf_auth.selectedIndex == "2") && (szHWInfo=="Atheros AR5K 802.11 Wireless LAN")) {
        flag=true;
    } else if ((form.rf_auth.selectedIndex == "3") && (szHWInfo=="Intersil Prism 802.11 Wireless LAN")) {
        flag=true;
//    } else if ( (frm.rf_wep.selectedIndex == "0") && ((frm.rf_auth.selectedIndex == "1")||(frm.rf_auth.selectedIndex == "2")) ) {
    } else if ( (frm.rf_wep.selectedIndex == "0") && (frm.rf_auth.selectedIndex == "1") ) {
        alert("Authenticate type should configure to \"open system\" while WEP disable"); 
        flag=false;
    } else {
        /* do nothing */
    }

    return flag;
}


/*=======================================================================
; Comment: Java Script for checking Wireless MAC
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/14
; Original Reference: KME project
;========================================================================*/
function CheckWirelessMac(form)
{
    if(form.rf_mac_enable[1].checked){
        for(var i = 1; i < 33; i++){
            if(CheckMAC(eval("form.rf_mac"+i), 0, 0) == false){
                alert("MAC "+i+" Invalid MAC Address( "+eval("form.rf_mac"+i).value+" ).");
                eval("form.rf_mac"+i).value = "";
                return false;
            }else{
                /* do nothing */
            }
        }
    }else{
        /* do nothing */
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking Wireless 802.1x
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWireless8021x(form)
{
    if(CheckIPAddress(form.dot1xAuthIPAddress, 0, 1) &&
       CheckPort(form.dot1xAuthPort, 0, 1) &&
       CheckText(form.dot1xAuthSecret)){
        return true;
    }else{
        alert("Please Reconfiguration Wireless 802.1x.");
        return flase;
    }
}
